Readme file for ATI Accelerator OS/2 PM Device Driver.

ATI Technologies Inc.                                           May 28, 1993
============================================================================


This ATI driver runs on the following products:

        Graphics Ultra Pro  (1MB, 2MB)
        Graphics Ultra Plus (1MB, 2MB)
        Graphics Ultra      (1MB)
        Graphics Vantage    (1MB)
        8514 Ultra          (1MB)

        and other OEM products identifying the Mach8 (ATI38800) or
            Mach32 (ATI68800) graphics accelerators.


The following versions of OS/2 are supported:

        OS/2 1.21
        OS/2 1.30
        OS/2 2.0
        OS/2 2.0 + Service Pack
        OS/2 2.1 Beta
        OS/2 2.1 Gamma (05/93)
        OS/2 2.1

NOTE:   This driver is still in beta form and is released with no
        implied warranties and/or guarantees of functionality. Do not
        use them in a production environment or for mission-critical
        activities, but do test it and give us your feedback. Questions
        and problem reports can be addressed to ATI Driver Development
        via the ATI forum on Compuserve (GO ATITECH) or by fax/letter
        addressed to the attention of:

                        ATI Technologies Inc.
                        3761 Victoria Park Avenue
                        Scarborough, Ontario
                        Canada       M1W 3S2
                        Driver Development
                        FAX: 416-756-0720



Supported Resolutions and Conditions
------------------------------------

For Mach32 products (Graphics Ultra Pro, Graphics Ultra Plus, etc)

                                Mininum Video Memory    VGA Memory Boundary
                                       Required              Setting

        1280x1024 (256 colors)          2 MB                 512 KB
        1024x768  (256 colors)          1 MB                 Shared *
        800x600   (256 colors)          1 MB                 512 KB
        640x480   (256 colors)          1 MB                 512 KB

* 512 KB on a 2MB card

If you have a 1 MB version of Mach32 card, this may cause some DOS
applications running in the background to corrupt the PM desktop. To
correct this problem, you need to upgrade the Mach32 card to 2MB video
memory and set the VGA memory boundary to 512KB or greater. The VGA
memory boundary can be changed using the Mach32 card installation
program (except on some OEM products, which supply their own
installation utility).


For Mach8 products (Graphics Ultra, Graphics Vantage, 8514 Ultra, etc)

                                Mininum Video Memory
                                       Required

        1024x768  (256 colors)          1 MB
        800x600   (256 colors)          1 MB
        640x480   (256 colors)          1 MB


To support a particular resolution, you must have sufficient video
memory, and the mode MUST be installed (using the card installation
utility). If you choose a resolution that is not supported or your card
has not been installed for, the PM driver will try to substitute one
that is.


Installing the Driver
---------------------

1. The OS/2 Presentation Manager should be set up with the primary display
   adapter type as 8514/A. This can be verified or changed by running
   "Selective Install" in the OS/2 System Setup.

2. Insert ATI PM driver installation diskette into drive A.

3. Open an DOS command prompt, type

        A:      [enter]
        INSTALL [enter]

   then follow the instructions on the screen. Please make sure that the
   correct OS/2 version is selected to install a PM driver.

5. Reboot into desired mode.

6. Repeat step 2 to 5 if you want to change the driver.


Known problems and limitations
------------------------------

. The OS/2 2.1 driver does not handle seamless Windows in this release,
  but it should do full screen Windows with the same resolution of the OS/2
  desktop except in the 1280x1024 mode on Mach32 cards. For Mach32 cards
  using 1280x1024 PM mode, the WIN-OS/2 Full Screen will use only 1024x768.

. 8514 Ultra users who are NOT using ATI VGA cards will not be able to
  do WIN-OS/2 Full Screen with OS/2 2.1 at the same resolution as the PM
  desktop when 640x480 or 800x600 resolution is selected. IF YOU ARE
  USING AN ATI VGA CARD, THIS DOES NOT APPLY. THIS DOES APPLY TO
  GRAPHICS ULTRA PRO USERS WITH VGA DISABLED (dual monitor
  configurations).

  If you are using another (non-ATI) brand of VGA, and wish to run the
  Full Screen Windows at lower than 1024x768 resolution, install the
  640x480 VGA Windows driver as follows:

  1. Insert ATI PM driver diskette into drive A.
  2. Open an DOS command prompt, type

        A:      [enter]
        LHARC E PMWIN drive:\OS2\MDOS\WINOS2\SYSTEM\ VGA.DRV

     where drive is the OS/2 2.1 boot disk.
  3. Press Enter.
  4. Edit the \OS2\WINOS2\SYSTEM.INI file.
  5. Change the DISPLAY.DRV=8514.DRV line to DISPLAY.DRV=VGA.DRV.
  6. Save and exit the file.
  7. Restart WIN-OS/2.

. Mach32 card users who select 640x480 or 800x600 should set the VGA
  memory boundary to either 256KB or 512KB if the WIN-OS/2 Full Screen
  support is desired. If a 256KB boundary is set, 16 color WIN-OS/2 Full
  Screen will be supported. A 512KB boundary will allow 256 color
  WIN-OS/2 Full Screen.


Coming Soon
-----------

The next release of the OS/2 2.1 driver will be a 32 bit driver which
gives a better performance than the current driver. It also supports
both 256 colors and 65536 colors modes on the Mach32 cards. Seamless
Windows will be supported as well.
